* Opens up Excel and sets up a DDE link with it
*
* Searches the registry for the file type .xls and determines the program to run
* Then sets up the DDE connection to Excel.
*
* Use DDEPoke() to send data to a cell in Excel
*   DDEPoke(mc, "R1C2", "The data for row 1 column 2")
*   See MakeRC() [below] for a function to make the "R1C1" style strings for you
*   See PokeRC() [below] for a function to automatically convert data for you too

* See XLMACR8.HLP for DDE commands you can use with DDEExecute()
*   DDEExecute(mc, '[SELECT("' + MakeRc(1,2) + '")]')
*   Macro commands can be executed with DDEExecute()


*!*	* Cut and paste this for an easy dump code
*!*	* This dumps a database to an Excel spreadsheet
*!*	* If the column name starts with "C_", it is formatted as currency.
*!*	* Change to suit your needs.
*!*	set procedure to l:\tyler\scripts\exceldde.prg additive
*!*	close data
*!*	select Period, Auditor, TypeCode, Typename, Cbtot as C_Cbtot, Cmtot as C_Cmtot, ;
*!*		nettot as C_Nettot, pcnt from aud_per order by period, auditor, typename ;
*!*		into cursor funky_bunch
*!*	sele funky_bunch
*!*	mc = StartExcelDDE()
*!*	afields(af)
*!*	R = 1
*!*	for i = 1 to fcount()
*!*		if substr(field(i), 1, 2) == 'C_' then
*!*			ddeexecute(mc, '[SELECT("C' + allt(str(i)) + '")][FORMAT.NUMBER("$#,##0.00")]')
*!*			ddepoke(mc, MakeRC(R,i), substr(field(i), 3))
*!*		else
*!*			DDEPoke(mc, MakeRC(R,i), field(i))
*!*		endif
*!*	next
*!*	ddeexecute(mc, '[SELECT("' + MakeRC(R, 1) + ':' + MakeRC(R, fcount()) + ;
*!*			'")][ALIGNMENT(3)][FONT.PROPERTIES(,"Bold")][BORDER(,,,,6)]')
*!*	R = R + 1
*!*	go top
*!*	do while ! eof()
*!*		for i = 1 to fcount()
*!*			d = af(i,1)
*!*			d = &d
*!*			if af(i,2) == 'N' then
*!*				DDEPoke(mc, MakeRC(R,i), allt(str(d, af(i,3), af(i,4))))
*!*			else
*!*				if (af(i,2) == 'I') then
*!*					DDEPoke(mc, MakeRC(R,i), allt(str(d)))
*!*				else
*!*					DDEPoke(mc, MakeRC(R,i), d)
*!*				endif
*!*			endif
*!*		next
*!*		skip
*!*		R = R + 1
*!*	enddo
*!*	ddeexecute(mc, '[COLUMN.WIDTH(,"R1C1:' + MakeRC(R, fcount()) + '",,3)]')


function StartExcelDDE
	local m.oReg, m.cExtn, m.cAppKey, m.cAppName, m.nErrNum, m.R, m.mc
	
	m.oReg = NewObject("FileReg", "L:\tyler\scripts\registry.prg")

	m.cExtn = "XLS"
	m.cAppKey = ""
	m.cAppName = ""

	nErrNum = oReg.GetAppPath(m.cExtn,@m.cAppKey,@m.cAppName)
	IF m.nErrNum != 0
		? "Excel registry key not found!"
		cancel
	ENDIF

	* Remove switches here (i.e., C:\EXCEL\EXCEL.EXE /e)
	IF ATC(".EXE",m.cAppName) #0
		m.cAppName= ALLTRIM(SUBSTR(m.cAppName,1,ATC(".EXE",m.cAppName)+3))
		IF ASC(LEFT(cAppName,1))=34	&&check for long file name in quotes
			m.cAppName = SUBSTR(m.cAppName,2)
		ENDIF
	ENDIF

	m.R = "! /N " + m.cAppName
	&R

	m.mc = DDEInitiate('Excel', 'Sheet1')
	
	if m.mc < 0
		? "Error communicating with Excel!"
		cancel
	endif

	return m.mc
endfunc


function MakeRc
lparameters m.R, m.C
	return 'R' + allt(str(m.R)) + 'C' + allt(str(m.C))
endfunc


function ExcelLandscape
lparameters m.mc
	ddeexecute(m.mc, '[PAGE.SETUP(,,,,,,,,,,2)]')		
endfunc

function ExcelLegal
lparameters m.mc
	ddeexecute(m.mc, '[PAGE.SETUP(,,,,,,,,,,,5)]')		
endfunc


function DDERequest2
lparameters m.mc, m.r, m.c
	local m.pos
	
	m.s = dderequest(m.mc, MakeRC(m.r, m.c))
	m.pos = at(chr(13), m.s)
	if m.pos > 0
		m.s = substr(m.s, 1, m.pos - 1)
	endif
	
	return allt(m.s)
endfunc